Xapian::FixedWeightPostingSource Class Reference

A posting source which returns a fixed weight for all documents. More...

Inheritance diagram for Xapian::FixedWeightPostingSource:
[legend]

## Public Member Functions

| FixedWeightPostingSource (double wt)
| Construct a FixedWeightPostingSource. More...
Xapian::doccount | get_termfreq_min () const
| A lower bound on the number of documents this object can return. More...
Xapian::doccount | get_termfreq_est () const
| An estimate of the number of documents this object can return. More...
Xapian::doccount | get_termfreq_max () const
| An upper bound on the number of documents this object can return. More...
double | get_weight () const
| Return the weight contribution for the current document. More...
void | next (double min_wt)
| Advance the current position to the next matching document. More...
void | skip_to (Xapian::docid min_docid, double min_wt)
| Advance to the specified docid. More...
bool | check (Xapian::docid min_docid, double min_wt)
| Check if the specified docid occurs. More...
bool | at_end () const
| Return true if the current position is past the last entry in this list. More...
Xapian::docid | get_docid () const
| Return the current docid. More...
FixedWeightPostingSource * | clone () const
| Clone the posting source. More...
std::string | name () const
| Name of the posting source class. More...
std::string | serialise () const
| Serialise object parameters into a string. More...
FixedWeightPostingSource * | unserialise (const std::string &serialised) const
| Create object given string serialisation returned by serialise(). More...
void | init (const Database &db_)
| Set this PostingSource to the start of the list of postings. More...
std::string | get_description () const
| Return a string describing this object. More...
Public Member Functions inherited from Xapian::PostingSource
| PostingSource ()
| Allow subclasses to be instantiated.
void | set_maxweight (double max_weight)
| Specify an upper bound on what get_weight() will return from now on. More...
double | get_maxweight () const
| Return the currently set upper bound on what get_weight() can return.
virtual PostingSource * | unserialise_with_registry (const std::string &serialised, const Registry &registry) const
| Create object given string serialisation returned by serialise(). More...

## Detailed Description

A posting source which returns a fixed weight for all documents.

This returns entries for all documents in the given database, with a fixed weight (specified by a parameter to the constructor).

## Constructor & Destructor Documentation

Xapian::FixedWeightPostingSource::FixedWeightPostingSource | ( | double | wt | ) |

explicit

Construct a FixedWeightPostingSource.

Parameters

  wt | The fixed weight to return.

## Member Function Documentation

bool Xapian::FixedWeightPostingSource::at_end | ( |  | ) | const

virtual

Return true if the current position is past the last entry in this list.

At least one of next(), skip_to() or check() will be called before this method is first called.

Implements Xapian::PostingSource.

bool Xapian::FixedWeightPostingSource::check | ( | Xapian::docid | did,
|  | double | min_wt
| ) |  |

virtual

Check if the specified docid occurs.

The caller is required to ensure that the specified document id did actually exists in the database. If it does, it must move to that document id, and return true. If it does not, it may either:

- return true, having moved to a definite position (including "at_end"), which must be the same position as skip_to() would have moved to.

or

- return false, having moved to an "indeterminate" position, such that a subsequent call to next() or skip_to() will move to the next matching position after did.

Generally, this method should act like skip_to() and return true if that can be done at little extra cost.

Otherwise it should simply check if a particular docid is present, returning true if it is, and false if it isn't.

The default implementation calls skip_to() and always returns true.

Xapian will always call init() on a PostingSource before calling this for the first time.

Note: in the case of a multi-database search, the docid specified is the docid in the single subdatabase relevant to this posting source. See the init() method for details.

Parameters

  did | The document id to check.
  min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Reimplemented from Xapian::PostingSource.

FixedWeightPostingSource* Xapian::FixedWeightPostingSource::clone | ( |  | ) | const

virtual

Clone the posting source.

The clone should inherit the configuration of the parent, but need not inherit the state. ie, the clone does not need to be in the same iteration position as the original: the matcher will always call init() on the clone before attempting to move the iterator, or read the information about the current position of the iterator.

This may return NULL to indicate that cloning is not supported. In this case, the PostingSource may only be used with a single-database search.

The default implementation returns NULL.

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: http://trac.xapian.org/ticket/554#comment:1

Reimplemented from Xapian::PostingSource.

std::string Xapian::FixedWeightPostingSource::get_description | ( |  | ) | const

virtual

Return a string describing this object.

This default implementation returns a generic answer. This default it provided to avoid forcing those deriving their own PostingSource subclass from having to implement this (they may not care what get_description() gives for their subclass).

Reimplemented from Xapian::PostingSource.

Xapian::docid Xapian::FixedWeightPostingSource::get_docid | ( |  | ) | const

virtual

Return the current docid.

This method may assume that it will only be called when there is a "current document". See get_weight() for details.

Note: in the case of a multi-database search, the returned docid should be in the single subdatabase relevant to this posting source. See the init() method for details.

Implements Xapian::PostingSource.

Xapian::doccount Xapian::FixedWeightPostingSource::get_termfreq_est | ( |  | ) | const

virtual

An estimate of the number of documents this object can return.

It must always be true that:

get_termfreq_min() <= get_termfreq_est() <= get_termfreq_max()

Xapian will always call init() on a PostingSource before calling this for the first time.

Implements Xapian::PostingSource.

Xapian::doccount Xapian::FixedWeightPostingSource::get_termfreq_max | ( |  | ) | const

virtual

An upper bound on the number of documents this object can return.

Xapian will always call init() on a PostingSource before calling this for the first time.

Implements Xapian::PostingSource.

Xapian::doccount Xapian::FixedWeightPostingSource::get_termfreq_min | ( |  | ) | const

virtual

A lower bound on the number of documents this object can return.

Xapian will always call init() on a PostingSource before calling this for the first time.

Implements Xapian::PostingSource.

double Xapian::FixedWeightPostingSource::get_weight | ( |  | ) | const

virtual

Return the weight contribution for the current document.

This default implementation always returns 0, for convenience when implementing "weight-less" PostingSource subclasses.

This method may assume that it will only be called when there is a "current document". In detail: Xapian will always call init() on a PostingSource before calling this for the first time. It will also only call this if the PostingSource reports that it is pointing to a valid document (ie, it will not call it before calling at least one of next(), skip_to() or check(), and will ensure that the PostingSource is not at the end by calling at_end()).

Reimplemented from Xapian::PostingSource.

void Xapian::FixedWeightPostingSource::init | ( | const Database & | db | ) |

virtual

Set this PostingSource to the start of the list of postings.

This is called automatically by the matcher prior to each query being processed.

If a PostingSource is used for multiple searches, init() will therefore be called multiple times, and must handle this by using the database passed in the most recent call.

Parameters

  db | The database which the PostingSource should iterate through.

Note: the database supplied to this method must not be modified: in particular, the reopen() method should not be called on it.

Note: in the case of a multi-database search, a separate PostingSource will be used for each database (the separate PostingSources will be obtained using clone()), and each PostingSource will be passed one of the sub-databases as the db parameter here. The db parameter will therefore always refer to a single database. All docids passed to, or returned from, the PostingSource refer to docids in that single database, rather than in the multi-database.

Implements Xapian::PostingSource.

std::string Xapian::FixedWeightPostingSource::name | ( |  | ) | const

virtual

Name of the posting source class.

This is used when serialising and unserialising posting sources; for example, for performing remote searches.

If the subclass is in a C++ namespace, the namespace should be included in the name, using "::" as a separator. For example, for a PostingSource subclass called "FooPostingSource" in the "Xapian" namespace the result of this call should be "Xapian::FooPostingSource".

This should only be implemented if serialise() and unserialise() are also implemented. The default implementation returns an empty string.

If this returns an empty string, Xapian will assume that serialise() and unserialise() are not implemented.

Reimplemented from Xapian::PostingSource.

void Xapian::FixedWeightPostingSource::next | ( | double | min_wt | ) |

virtual

Advance the current position to the next matching document.

The PostingSource starts before the first entry in the list, so next() must be called before any methods which need the context of the current position.

Xapian will always call init() on a PostingSource before calling this for the first time.

Parameters

  min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Implements Xapian::PostingSource.

std::string Xapian::FixedWeightPostingSource::serialise | ( |  | ) | const

virtual

Serialise object parameters into a string.

The serialised parameters should represent the configuration of the posting source, but need not (indeed, should not) represent the current iteration state.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Reimplemented from Xapian::PostingSource.

void Xapian::FixedWeightPostingSource::skip_to | ( | Xapian::docid | did,
|  | double | min_wt
| ) |  |

virtual

Advance to the specified docid.

If the specified docid isn't in the list, position ourselves on the first document after it (or at_end() if no greater docids are present).

If the current position is already the specified docid, this method will leave the position unmodified.

If the specified docid is earlier than the current position, the behaviour is unspecified. A sensible behaviour would be to leave the current position unmodified, but it is also reasonable to move to the specified docid.

The default implementation calls next() repeatedly, which works but skip_to() can often be implemented much more efficiently.

Xapian will always call init() on a PostingSource before calling this for the first time.

Note: in the case of a multi-database search, the docid specified is the docid in the single subdatabase relevant to this posting source. See the init() method for details.

Parameters

  did | The document id to advance to.
  min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Reimplemented from Xapian::PostingSource.

FixedWeightPostingSource* Xapian::FixedWeightPostingSource::unserialise | ( | const std::string & | serialised | ) | const

virtual

Create object given string serialisation returned by serialise().

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: http://trac.xapian.org/ticket/554#comment:1

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Parameters

  serialised | A serialised instance of this PostingSource subclass.

Reimplemented from Xapian::PostingSource.

The documentation for this class was generated from the following file:

- xapian/postingsource.h